unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TSpielfeld = class(TForm)
    Uhr: TTimer;
    Bild: TImage;
    procedure FormCreate(Sender: TObject);
    procedure UhrTimer(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const BallMax=10;FMax=15;
      Farben:Array[0..FMax]of TColor=
                     (clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple,
                      clTeal, clGray, clSilver, clRed, clLime, clYellow,
                      clBlue, clFuchsia, clAqua, clWhite);

type TBall=class
  MittelPunkt,Richtung:TPoint;
  Radius : Integer;
  Farbe       : tColor;
  procedure Init(fNeu: tColor;MitteNeu,RichtungNeu:TPoint;RadiusNeu: Integer);
  procedure ZeigeDich;
  procedure BewegeDich;
  function Trifft(anderenBall:TBall):Boolean;
  procedure GeschwindigkeitTauschen(anderenBall:TBall);
  end;
var
  Spielfeld:TSpielfeld;
  roterBall,blauerBall,gruenerBall:TBall;
  BallListe:Array[0..BallMax]of TBall;
  K:Integer;
implementation
{$R *.dfm}

 procedure TBall.Init(fNeu:tColor;MitteNeu,RichtungNeu:TPoint;RadiusNeu:Integer);
  begin
   Farbe:=fneu;
   Radius:=RadiusNeu;
   MittelPunkt:=MitteNeu;
   Richtung:=RichtungNeu;
  end;

 procedure TBall.ZeigeDich;
  begin
   with Spielfeld.Bild.Canvas do
    begin
     Brush.Color:=Farbe;
     Ellipse(MittelPunkt.X-Radius,MittelPunkt.Y-Radius,MittelPunkt.X+Radius,MittelPunkt.Y+Radius)
    end;
  end;

 procedure TBall.BewegeDich;
  begin
   MittelPunkt.X:=MittelPunkt.X+Richtung.X;
   MittelPunkt.Y:=MittelPunkt.Y+Richtung.Y;
   with Spielfeld.Bild do
    begin
     if (MittelPunkt.X>Width-Radius-1) then
      begin
       Beep;
       MittelPunkt.X:=Width-Radius-1;
       Richtung.X:=-Richtung.X;
      end;
     if MittelPunkt.X<Radius+1 then
      begin
       Beep;
       MittelPunkt.X:=Radius+1;
       Richtung.X:=-Richtung.X;
      end;
     if (MittelPunkt.Y>Height-Radius-1) then
      begin
       Beep;
       MittelPunkt.Y:=Height-Radius-1;
       Richtung.Y:=-Richtung.Y;
      end;
     if MittelPunkt.Y<Radius+1 then
      begin
       Beep;
       MittelPunkt.Y:=Radius+1;
       Richtung.Y:=-Richtung.Y;
      end
    end
  end;

 function TBall.trifft(anderenBall:TBall):Boolean;
  begin
   Result:=False;
   if (abs(MittelPunkt.X-anderenBall.MittelPunkt.X)<=2*Radius) and
      (abs(MittelPunkt.Y-anderenBall.MittelPunkt.Y)<=2*Radius) then Result:=True
  end;

 procedure TBall.GeschwindigkeitTauschen(anderenBall:TBall);
  var Tausch:TPoint;
  begin
   Tausch:=Richtung;
   Richtung:=anderenBall.Richtung;
   anderenBall.Richtung:=Tausch;
  end;

 procedure TSpielfeld.FormCreate(Sender: TObject);
  var M,R:TPoint;
  begin
   with Bild.Canvas do
    begin
     pen.width:=5;
     brush.Color:=clWhite;
     rectangle(0,0,Bild.width,Bild.Height);
     pen.width:=2;
     brush.style:=bsSolid;
     pen.mode:=pmNOTXOR;
    end;
   M.X:=random(Bild.Width-50)+25;
   M.Y:=random(Bild.Height-50)+25;
   R.X:=random(9)-4;
   R.Y:=random(9)-4;
   roterBall.init(clRed,M,R,20);
   M.X:=random(Bild.Width-50)+25;
   M.Y:=random(Bild.Height-50)+25;
   R.X:=random(9)-4;
   R.Y:=random(9)-4;
   blauerBall.init(clBlue,M,R,15);
   M.X:=random(Bild.Width-50)+25;
   M.Y:=random(Bild.Height-50)+25;
   R.X:=random(9)-4;
   R.Y:=random(9)-4;
   gruenerBall.init(clGreen,M,R,10);
   roterBall.ZeigeDich;
   blauerBall.ZeigeDich;
   gruenerBall.ZeigeDich;
  end;

 procedure TSpielfeld.UhrTimer(Sender: TObject);
  begin
   roterBall.ZeigeDich;
   roterBall.BewegeDich;
   roterBall.ZeigeDich;
   blauerBall.ZeigeDich;
   blauerBall.BewegeDich;
   blauerBall.ZeigeDich;
   gruenerBall.ZeigeDich;
   gruenerBall.BewegeDich;
   gruenerBall.ZeigeDich;
   if roterBall.trifft(blauerBall) then
    begin
     Beep;
     roterBall.GeschwindigkeitTauschen(blauerBall);
    end;
   if roterBall.trifft(gruenerBall) then
    begin
     Beep;
     roterBall.GeschwindigkeitTauschen(gruenerBall);
    end;
   if blauerBall.trifft(gruenerBall) then
    begin
     Beep;
     blauerBall.GeschwindigkeitTauschen(gruenerBall);
    end;
  end;

 Initialization
  Randomize;
  roterBall:=TBall.Create;
  blauerBall:=TBall.Create;
  gruenerBall:=TBall.Create;
  for K:=0 to BallMax do
   BallListe[K]:=TBall.Create;
 Finalization
  roterBall.Destroy;
  blauerBall.Destroy;
  gruenerBall.Destroy;
end.

